【Java SE语法篇】11.异常

简介: 【Java SE语法篇】11.异常


1. 异常的概念和体系结构

1.1 异常的概念

在生活中,一个人表情痛苦,出于关心,可能会问:你是不是生病了,需要我陪你去看医生吗?

在程序中也是一样,程序猿是一帮办事严谨、追求完美的人才。在日常开发中,绞尽脑汁将代码写的完美,在程序运行过程中,难免会出现一些奇奇怪怪的问题,有时通过代码很难去控制,比如:数据格式不对、网络不通畅、内存报警等。

在 Java中,将程序执行过程中发生的不正常行为称为异常。比如之前写代码时经常遇到的:

  1. 算术异常

  2. 数组越界异常

  3. 空指针异常

从上述过程中可以看到,Java 中不同类型的的异常,都有与其对应的类进行描述

1.2 异常体系

异常种类繁多,为了对不同异常或者错误进行很好的分类管理,Java内部维护了一个异常的体系结构:

从上图中可以看到:

  1. Throwable是异常体系的顶层类,其派生出两个重要的子类, ErrorException
  2. Error:**指的是Java虚拟机无法解决的严重问题,**比如:JVM 的内部错误、资源耗尽等,典型代表:StackOverflowErrorOutOfMemoryError,一旦发生回力乏术。
  3. Exception:异常产生后程序员可以通过代码进行处理,使程序继续执行。比如:感冒、发烧。我们平时所说的异常就是Exception

1.3 异常的分类

异常可能在编译时发生,也可能在程序运行时发生,根据发生的时机不同,可以将异常分为:

  1. 编译时异常
    在程序编译期间发生的异常,称为编译时异常,也称为受检查异常(Checked Exception)

  2. 运行时异常
    在程序执行期间发生的异常,称为运行时异常,也称为非受检查异常(Unchecked Exception)
    RunTimeException以及其子类对应的异常,都称为运行时异常。比如:NullPointerException
    ArrayIndexOutOfBoundsExceptionArithmeticException
    【注意】:编译时出现的语法性错误,不能称之为异常。例如将 System.out.println 拼写错了, 写成了
    System.out.println. 此时编译过程中就会出错, 这是 “编译期” 出错。而运行时指的是程序已经编译通过得到class 文件了, 再由 JVM 执行过程中出现的错误.

2. 异常的处理

2.1 防御式编程

错误在代码中是客观存在的. 因此我们要让程序出现问题的时候及时通知程序猿. 主要的方式

  1. LBYL: Look Before You Leap. 在操作之前就做充分的检查. 即:事前防御型
boolean ret = false;
ret = 登陆游戏();
if (!ret) {
  处理登陆游戏错误;
  return;
} 
ret = 开始匹配();
if (!ret) {
  处理匹配错误;
  return;
}
ret = 游戏确认();
if (!ret) {
  处理游戏确认错误;
  return;
} 
ret = 选择英雄();
if (!ret) {
  处理选择英雄错误;
  return;
} 
ret = 载入游戏画面();
if (!ret) {
  处理载入游戏错误;
  return;
}
......
  1. 缺陷:正常流程和错误处理流程代码混在一起, 代码整体显的比较混乱。
  2. EAFP: It’s Easier to Ask Forgiveness than Permission. “事后获取原谅比事前获取许可更容易”. 也就是先操作, 遇到问题再处理. 即:事后认错型
try {
  登陆游戏();
  开始匹配();
  游戏确认();
  选择英雄();
  载入游戏画面();
...
} catch (登陆游戏异常) {
  处理登陆游戏异常;
} catch (开始匹配异常) {
  处理开始匹配异常;
} catch (游戏确认异常) {
  处理游戏确认异常;
} catch (选择英雄异常) {
  处理选择英雄异常;
} catch (载入游戏画面异常) {
  处理载入游戏画面异常;
}
......
  1. 优势:正常流程和错误流程是分离开的, 程序员更关注正常流程,代码更清晰,容易理解代码

异常处理的核心思想就是 EAFP。

在Java中,异常处理主要的5个关键字:throw、try、catch、finally、throws

2.2 异常的抛出

在编写程序时,如果程序中出现错误,此时就需要将错误的信息告知给调用者,比如:参数检测。

在Java中,可以借助throw关键字,抛出一个指定的异常对象,将错误信息告知给调用者。具体语法如下:

throw new XXXException("异常产生的原因");

代码示例:

public class Test {
    private static int getSubscript(int[] arr, int index) {
        if (arr == null) {
            throw new NullPointerException("数组为空");
        }
        if (index < 0 || index >= arr.length) {
            throw new ArithmeticException("下标越界");
        }
        return arr[index];
    }
    public static void main(String[] args) {
        int[] arr = {1,2,3};
        getSubscript(arr,3);
    }
}

运行结果:

一般情况下通过throw抛出的是自定义的异常

注意事项

  1. throw必须写在方法体内部
  2. 抛出的对象必须是Exception 或者Exception 的子类对象
  3. 如果抛出的是 RunTimeException 或者 RunTimeException 的子类,则可以不用处理,直接交给JVM来处理
  4. 如果抛出的是编译时异常,用户必须处理,否则无法通过编译
  5. 异常一旦抛出,其后的代码就不会执行

2.3 异常的捕获

异常的捕获,也就是异常的具体处理方式,主要有两种:异常声明throws 以及 try-catch捕获处理。

2.3.1 异常声明throws

处在方法声明时参数列表之后,当方法中抛出编译时异常,用户不想处理该异常,此时就可以借助throws将异常抛给方法的调用者来处理。即当前方法不处理异常,提醒方法的调用者处理异常。

语法格式:

修饰符  返回值类型   方法名(参数列表) throws 异常类型1,异常类型2...{
}

【注意事项】

  1. throws必须跟在方法的参数列表之后

  2. 声明的异常必须是 Exception 或者 Exception 的子类
  3. 方法内部如果抛出了多个异常,throws之后必须跟多个异常类型,之间用逗号隔开,如果抛出多个异常类型具有父子关系,直接声明父类即可。

  1. 调用声明抛出异常的方法时,调用者必须对该异常进行处理,或者继续使用throws抛出

2.3.2 try - catch捕获并处理

throws对异常并没有真正处理,而是将异常报告给抛出异常方法的调用者,由调用者处理。如果真正要对异常进行处理,就需要try-catch

语法格式:

try{
  // 将可能出现异常的代码放在这里
}catch(要捕获的异常类型  e){
     // 如果try中的代码抛出异常了,此处catch捕获时异常类型与try中抛出的异常类型一致时,或者是try中抛出异常的基类
时,就会被捕获到
     // 对异常就可以正常处理,处理完成后,跳出try-catch结构,继续执行后序代码
}[catch(异常类型 e){
    // 对异常进行处理
}finally{
      // 此处代码一定会被执行到
}]
// 后序代码
// 当异常被捕获到时,异常就被处理了,这里的后序代码一定会执行
// 如果捕获了,由于捕获时类型不对,那就没有捕获到,这里的代码就不会被执行

注意:

  1. []中表示可选项,可以添加,也可以不用添加
  2. try中的代码可能会抛出异常,也可能不会

代码示例

public class Test {
    public static void fun() throws NullPointerException {
        int[] arr = null;
        System.out.println(arr.length);
    }
    public static void main(String[] args){
        try {
            fun();
        } catch (NullPointerException e) {
            e.printStackTrace();
            System.out.println("处理NullPointerException异常!");
        }
        System.out.println("haha");
    }
}

运行结果:

关于异常的处理方式

异常的种类有很多, 我们要根据不同的业务场景来决定.

对于比较严重的问题(例如和算钱相关的场景), 应该让程序直接崩溃, 防止造成更严重的后果

对于不太严重的问题(大多数场景), 可以记录错误日志, 并通过监控报警程序及时通知程序猿

对于可能会恢复的问题(和网络相关的场景), 可以尝试进行重试.

在我们当前的代码中采取的是经过简化的第二种方式. 我们记录的错误日志是出现异常的方法调用信息, 能很快速的让我们找到出现异常的位置. 以后在实际工作中我们会采取更完备的方式来记录异常信息.

【注意事项】:

  1. try块内抛出异常位置之后的代码将不会被执行
  2. 如果抛出异常类型与catch时异常类型不匹配,即异常不会被成功捕获,也就不会被处理,继续往外抛,直到 JVM 收到后中断程序----异常是按照类型来捕获的

  1. try中可能会抛出多个不同的异常对象,则必须用多个catch来捕获----即多种异常,多次捕获
public class Test {
    public static void main(String[] args) {
        try {
            int[] arr = {1,2,3};
            System.out.println(arr[9]);
        } catch (NullPointerException e) {
            e.printStackTrace();
            System.out.println("捕获NullPointerException异常!");
        } catch (ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
            System.out.println("捕获ArrayIndexOutOfBoundsException异常");
        }
        System.out.println("后续代码");
    }
}

如果多个异常的处理方式是完全相同, 也可以写成这样:

public class Test {
    public static void main(String[] args) {
        try {
            int[] arr = {1,2,3};
            System.out.println(arr[9]);
        } catch (NullPointerException | ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
            System.out.println("捕获NullPointerException或者ArrayIndexOutOfBoundsException异常!");
        }
        System.out.println("后续代码");
    }
}

如果异常之间具有父子关系,一定是子类异常在前catch,父类异常在后catch,否则语法错误:

正确形式:

public class Test {
    public static void main(String[] args) {
        try {
            int[] arr = {1,2,3};
            System.out.println(arr[9]);
        } catch (NullPointerException | ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
            System.out.println("捕获NullPointerException或者ArrayIndexOutOfBoundsException异常!");
        } catch (RuntimeException e) {
            e.printStackTrace();
        }
        System.out.println("后续代码");
    }
}
  1. 可以通过一个catch捕获所有的异常,即多个异常,一次捕获(不推荐)
public class Test {
    public static void main(String[] args) {
        try {
            int[] arr = {1,2,3};
            System.out.println(arr[9]);
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("捕获异常!");
        }
        System.out.println("后续代码");
    }
}

由于 Exception 类是所有异常类的父类. 因此可以用这个类型表示捕捉所有异常

备注: catch 进行类型匹配的时候, 不光会匹配相同类型的异常对象, 也会捕捉目标异常类型的子类对象.如刚才的代码, NullPointerExceptionArrayIndexOutOfBoundsException 都是 Exception 的子类,因此都能被捕获到.

2.3.3 finally

在写程序时,有些特定的代码,不论程序是否发生异常,都需要执行,比如程序中打开的资源:网络连接、数据库连接、IO流等,在程序正常或者异常退出时,必须要对资源进进行回收。另外,因为异常会引发程序的跳转,可能导致有些语句执行不到finally就是用来解决这个问题的。

语法格式:

try{
  // 可能会发生异常的代码
}catch(异常类型 e){
  // 对捕获到的异常进行处理
}finally{
  // 此处的语句无论是否发生异常,都会被执行到
} 
// 如果没有抛出异常,或者异常被捕获处理了,这里的代码也会执行

代码示例

public class Test {
    public static void main(String[] args) {
        try {
            int[] arr = {1,2,3};
            System.out.println(arr[9]);
        } catch (ArrayIndexOutOfBoundsException e) {
            e.printStackTrace();
            System.out.println("捕获ArrayIndexOutOfBoundsException异常");
        } finally {
            System.out.println("finally被执行了");
        }
        System.out.println("后续代码");
    }
}

问题:既然 finally 和 try-catch-finally 后的代码都会执行,那为什么还要有finally呢?

代码示例:

public class Test {
    public static int func() {
        Scanner input = new Scanner(System.in);
        try {
            int a = input.nextInt();
            return a; // 这个return 不影响finally执行
        } catch (IncompatibleClassChangeError e) {
            e.printStackTrace();
            System.out.println("捕获到IncompatibleClassChangeError异常");
        } finally {
            System.out.println("finally被执行了");
        }
        if (input != null) {
            input.close();
        }
        return -1;
    }
    
    public static void main(String[] args) {
        System.out.println(func());
    }
}

上述程序,如果正常输入,成功接收输入后程序就返回了,try-catch-finally之后的代码根本就没有执行,即输入流就没有被释放,造成资源泄漏

优化代码:

public class Test {
    public static int func() {
        Scanner input = new Scanner(System.in);
        try {
            int a = input.nextInt();
            return a; // 这个return 不影响finally执行
        } catch (IncompatibleClassChangeError e) {
            e.printStackTrace();
            System.out.println("捕获到IncompatibleClassChangeError异常");
        } finally {
            System.out.println("finally被执行了");
            input.close();
        }
        return -1;
    }
    public static void main(String[] args) {
        System.out.println(func());
    }
}

注意:finally中的代码一定会执行的,一般在finally中进行一些资源清理的扫尾工作

2.4 异常的处理流程

关于 “调用栈”

方法之间是存在相互调用关系的, 这种调用关系我们可以用 “调用栈” 来描述. 在 JVM 中有一块内存空间称为"虚拟机栈" 专门存储方法之间的调用关系. 当代码中出现异常的时候, 我们就可以使用 e.printStackTrace(); 的方式查看出现异常代码的调用栈.

如果本方法中没有合适的处理异常的方式, 就会沿着调用栈向上传递

如果向上一直传递都没有合适的方法处理异常, 最终就会交给 JVM 处理, 程序就会异常终止(和我们最开始未使用 try-catch 时是一样的).

可以看到, 程序已经异常终止了, 没有执行到 System.out.println("后续代码"); 这一行

优化代码

public class Test {
    public static int func() {
        try {
            int[] arr = {1,2,3};
            System.out.println(arr[10]);
        } catch (NullPointerException e) {
            e.printStackTrace();
            System.out.println("捕获到NullPointerException异常");
        } finally {
            System.out.println("finally被执行了");
        }
        System.out.println("后续代码");
        return -1;
    }
    public static void main(String[] args) {
        try {
            System.out.println(func());
        } catch (ArrayIndexOutOfBoundsException e) { // main方法处理异常
            e.printStackTrace();
            System.out.println("ArrayIndexOutOfBoundsException");
        } finally {
        }
        System.out.println("后续代码...");
    }
}

异常处理流程总结

  • 程序先执行 try 中的代码
  • 如果 try 中的代码出现异常, 就会结束 try 中的代码, 看和 catch 中的异常类型是否匹配.
  • 如果找到匹配的异常类型, 就会执行 catch 中的代码
  • 如果没有找到匹配的异常类型, 就会将异常向上传递到上层调用者.
  • 无论是否找到匹配的异常类型, finally 中的代码都会被执行到(在该方法结束之前执行).
  • 如果上层调用者也没有处理的了异常, 就继续向上传递.
  • 一直到 main 方法也没有合适的代码处理异常, 就会交给 JVM 来进行处理, 此时程序就会异常终止

3. 自定义异常

Java 中虽然已经内置了丰富的异常类, 但是并不能完全表示实际开发中所遇到的一些异常,此时就需要维护符合我们实际情况的异常结构.

例如, 我们实现一个用户登陆功能

class Login {
    public String userName = "admin";
    public String passWord = "12345";
    public void login(String userName, String passWord) {
        if (!this.userName.equals(userName)) {
            System.out.println("用户名错误");
        }
        if (!this.passWord.equals(passWord)) {
            System.out.println("密码错误");
        }
    }
}
public class Test {
    public static void main(String[] args) {
        Login login = new Login();
        login.login("admin","123");
    }
}

此时我们在处理用户名密码错误的时候可能就需要抛出两种异常. 我们可以基于已有的异常类进行扩展(继承), 创建和我们业务相关的异常类

具体方式:

  1. 自定义异常类,然后继承自Exception 或者 RunTimeException
  2. 实现一个带有String类型参数的构造方法,参数含义:出现异常的原因
public class UserNameException extends RuntimeException{
    public UserNameException() {
        super();
    }
    public UserNameException(String message) {
        super(message);
    }
}
public class PasswordException extends RuntimeException{
    public PasswordException() {
        super();
    }
    public PasswordException(String message) {
        super(message);
    }
}

此时我们的 login 代码可以改成

class Login {
    public String userName = "admin";
    public String passWord = "12345";
    public void login(String userName, String passWord) {
        if (!this.userName.equals(userName)) {
            //System.out.println("用户名错误");
            throw new UserNameException("用户名错误");
        }
        if (!this.passWord.equals(passWord)) {
            //System.out.println("密码错误");
            throw new PasswordException("密码错误");
        }
    }
}
public class Test {
    public static void main(String[] args) {
        Login login = new Login();
        try {
            login.login("admin","123");
        } catch (UserNameException e) {
            e.printStackTrace();
        } catch (PasswordException e) {
            e.printStackTrace();
        }
        System.out.println("后续代码...");
    }
}

【注意事项】

  • 自定义异常通常会继承自 Exception 或者 RuntimeException
  • 继承自 Exception 的异常默认是受查异常
  • 继承自 RuntimeException 的异常默认是非受查异常
相关文章
|
4天前
|
存储 安全 Java
Java语法掌握:打好编程基础的关键(二)
Java语法掌握:打好编程基础的关键
25 0
|
4天前
|
存储 Java
Java语法掌握:打好编程基础的关键(一)
Java语法掌握:打好编程基础的关键
10 0
Java语法掌握:打好编程基础的关键(一)
|
26天前
|
SQL Java
java中的异常
java中的异常
8 1
|
26天前
|
Java 程序员 编译器
Java中异常
Java中异常
11 0
|
27天前
|
Java 程序员 编译器
Java中的异常
Java中的异常
8 0
|
27天前
|
Java
Java异常的抛出
Java异常的抛出
8 0
|
30天前
|
Java 索引
JAVA异常类及其主要方法
JAVA异常类及其主要方法
25 3
|
Java 程序员 编译器
Java异常——throw、throws及自定义异常
Java异常——throw、throws及自定义异常
109 0